## pgbouncer 1.1.2

=== Makefile ===

# sources
SRCS = client.c loader.c objects.c pooler.c proto.c sbuf.c server.c util.c \
       admin.c stats.c takeover.c md5.c janitor.c pktbuf.c system.c main.c \
       varcache.c
HDRS = client.h loader.h objects.h pooler.h proto.h sbuf.h server.h util.h \
       admin.h stats.h takeover.h md5.h janitor.h pktbuf.h system.h bouncer.h \
       list.h mbuf.h varcache.h

# data & dirs to include in tgz
DOCS = doc/overview.txt doc/usage.txt doc/config.txt doc/todo.txt
MANPAGES = doc/pgbouncer.1 doc/pgbouncer.5
DATA = README NEWS AUTHORS etc/pgbouncer.ini Makefile config.mak.in config.h.in \
       configure configure.ac debian/packages debian/changelog doc/Makefile \
       test/Makefile test/asynctest.c test/conntest.sh test/ctest6000.ini \
       test/ctest7000.ini test/run-conntest.sh test/stress.py test/test.ini \
       test/test.sh test/userlist.txt etc/example.debian.init.sh doc/fixman.py
DIRS = doc etc src debian test

# keep autoconf stuff separate
-include config.mak

ifeq ($(enable_debug),yes)
CFLAGS += -DDBGVER="\"compiled by <$${USER}@`hostname`> at `date '+%Y-%m-%d %H:%M:%S'`\""
endif

# calculate full-path values
OBJS = $(SRCS:.c=.o)
hdrs = $(addprefix $(srcdir)/src/, $(HDRS))
srcs = $(addprefix $(srcdir)/src/, $(SRCS))
objs = $(addprefix $(builddir)/lib/, $(OBJS))
FULL = $(PACKAGE_TARNAME)-$(PACKAGE_VERSION)
DISTFILES = $(DIRS) $(DATA) $(DOCS) $(srcs) $(hdrs) $(MANPAGES)

# Quiet by default, 'make V=1' shows commands
V=0
ifeq ($(V), 0)
Q = @
E = @echo
else
Q = 
E = @true
endif

## actual targets now ##

# default target
all: pgbouncer doc-all

# final executable
pgbouncer: config.mak $(objs)
	$(E) "	LD" $@
	$(Q) $(CC) -o $@ $(LDFLAGS) $(objs) $(LIBS)

# objects depend on all the headers
$(builddir)/lib/%.o: $(srcdir)/src/%.c config.mak $(hdrs)
	@mkdir -p $(builddir)/lib
	$(E) "	CC" $<
	$(Q) $(CC) -c -o $@ $< $(DEFS) $(CFLAGS) $(CPPFLAGS)

# install binary and other stuff
install: pgbouncer doc-install
	mkdir -p $(DESTDIR)$(bindir)
	mkdir -p $(DESTDIR)$(docdir)
	$(BININSTALL) -m 755 pgbouncer $(DESTDIR)$(bindir)
	$(INSTALL) -m 644 $(srcdir)/etc/pgbouncer.ini  $(DESTDIR)$(docdir)

# create tarfile
tgz: config.mak $(DISTFILES) $(MANPAGES)
	rm -rf $(FULL) $(FULL).tgz
	mkdir $(FULL)
	(for f in $(DISTFILES); do echo $$f; done) | cpio -p $(FULL)
	tar czf $(FULL).tgz $(FULL)
	rm -rf $(FULL)

doc/pgbouncer.1:
	make -C doc pgbouncer.1

doc/pgbouncer.5:
	make -C doc pgbouncer.5

# create debian package
deb: configure
	yada rebuild
	debuild -uc -us -b

# clean object files
clean: doc-clean
	rm -f *~ src/*~ *.o src/*.o lib/*.o lib/*.s pgbouncer core core.*
	rm -f lib/*.log

# clean configure results
distclean: clean doc-distclean
	rm -f config.h config.log config.status config.mak
	rm -rf lib autom4te*

# clean autoconf results
realclean: distclean doc-realclean
	rm -f aclocal* config.h.in configure depcomp install-sh missing
	rm -f tags

# generate configure script and config.h.in
boot: distclean
	autoreconf -i -f
	rm -rf autom4te* config.h.in~

# targets can depend on this to force ./configure
config.mak::
	@test -f configure || { \
		 echo "Please run 'make boot && ./configure' first.";exit 1;}
	@test -f $@ || { echo "Please run ./configure first.";exit 1;}

doc-all doc-install doc-clean doc-distclean doc-realclean:
	$(MAKE) -C doc $(subst doc-,,$@) DESTDIR=$(DESTDIR)


# targets can depend on this to force 'make boot'
configure::
	@test -f $@ || { echo "Please run 'make boot' first.";exit 1;}

# create tags file
tags: $(srcs) $(hdrs)
	if test -f ../libevent/event.h; then \
	  ctags $(srcs) $(hdrs) ../libevent/*.[ch]; \
	else \
	  ctags $(srcs) $(hdrs); \
	fi

# fixes for macos
SPARSE_MACOS=-D__STDC_VERSION__=199901 -D__LP64__=0 -DSENDFILE=1 \
		-I/usr/lib/gcc/i486-linux-gnu/4.1.2/include
# sparse does not have any identity
SPARCE_FLAGS=-D__LITTLE_ENDIAN__ -D__i386__ -D__GNUC__=3 -D__GNUC_MINOR__=0 \
		-Wno-transparent-union \
		-Wall $(SPARSE_MACOS) $(CPPFLAGS) $(DEFS)

# run sparse over code
check: config.mak
	$(E) "	CHECK" $(srcs)
	$(Q) sparse $(SPARCE_FLAGS) $(srcs)

pgbouncer.pg:
	$(CC) -pg $(DEFS) -g -O2 $(CPPFLAGS) $(LDFLAGS) -o $@ $(srcs) $(LIBS)

pg: pgbouncer.pg

$(builddir)/lib/%.s: $(srcdir)/src/%.c config.mak $(hdrs)
	@mkdir -p $(builddir)/lib
	$(E) "	CC -S" $<
	$(Q) $(CC) -S -o $@ $< $(DEFS) $(CFLAGS) $(CPPFLAGS)
asms = $(objs:.o=.s)
asm: $(asms)

=== doc/Makefile ===

wiki = https://developer.skype.com/SkypeGarage/DbProjects/PgBouncer
web = mkz@shell.pgfoundry.org:/home/pgfoundry.org/groups/pgbouncer/htdocs/

-include ../config.mak

MANPAGES = pgbouncer.1 pgbouncer.5
HTML = config.html usage.html todo.html faq.html

all: $(MANPAGES)

html: $(HTML)

install: $(MANPAGES)
	mkdir -p $(DESTDIR)$(mandir)/man1/
	mkdir -p $(DESTDIR)$(mandir)/man5/
	install -m 644 pgbouncer.1 $(DESTDIR)$(mandir)/man1/
	install -m 644 pgbouncer.5 $(DESTDIR)$(mandir)/man5/

upload:
	devupload.sh overview.txt $(wiki)
	#devupload.sh todo.txt $(wiki)/ToDo
	#devupload.sh usage.txt $(wiki)/UsageInfo
	#devupload.sh config.txt $(wiki)/ConfigFile

ifneq ($(XMLTO),)
pgbouncer.1: usage.xml
	xmlto man $<

pgbouncer.5: config.xml
	xmlto man $<
endif

ifneq ($(ASCIIDOC),)
%.xml: %.txt
	#asciidoc -b docbook -d manpage -o - $< > $@
	asciidoc -b docbook -d manpage -o - $< \
	| python fixman.py > $@

%.html: %.txt
	asciidoc -a toc $<
endif

clean:
	rm -f *.html

distclean: clean
	rm -f *.xml

realclean: distclean
	rm -f *.[1-9]

web: $(HTML)
	rsync -av $(HTML) $(web)/doc/

=== test/Makefile ===

PGINC = -I$(shell pg_config --includedir)
PGLIB = -L$(shell pg_config --libdir)

include ../config.mak

CPPFLAGS += -I../src $(PGINC)
LDFLAGS += $(PGLIB) -lpq -levent

all: asynctest

asynctest: asynctest.c
	$(CC) -o $@ $< $(CPPFLAGS) $(CFLAGS) $(LDFLAGS)

clean:
	rm -f asynctest

## pgbouncer 1.2.3

=== Makefile ===

# sources
SRCS = client.c loader.c objects.c pooler.c proto.c sbuf.c server.c util.c \
       admin.c stats.c takeover.c md5.c janitor.c pktbuf.c system.c main.c \
       varcache.c aatree.c hash.c slab.c
HDRS = client.h loader.h objects.h pooler.h proto.h sbuf.h server.h util.h \
       admin.h stats.h takeover.h md5.h janitor.h pktbuf.h system.h bouncer.h \
       list.h mbuf.h varcache.h aatree.h hash.h slab.h iobuf.h

# data & dirs to include in tgz
DOCS = doc/overview.txt doc/usage.txt doc/config.txt doc/todo.txt
MANPAGES = doc/pgbouncer.1 doc/pgbouncer.5
DATA = README NEWS AUTHORS etc/pgbouncer.ini etc/userlist.txt Makefile \
       config.mak.in include/config.h.in \
       configure configure.ac debian/packages debian/changelog doc/Makefile \
       test/Makefile test/asynctest.c test/conntest.sh test/ctest6000.ini \
       test/ctest7000.ini test/run-conntest.sh test/stress.py test/test.ini \
       test/test.sh test/userlist.txt etc/example.debian.init.sh doc/fixman.py
DIRS = doc etc include src debian test

# keep autoconf stuff separate
-include config.mak

# fill values for unconfigured tree
srcdir ?= .
builddir ?= .

# calculate full-path values
OBJS = $(SRCS:.c=.o)
hdrs = $(addprefix $(srcdir)/include/, $(HDRS))
srcs = $(addprefix $(srcdir)/src/, $(SRCS))
objs = $(addprefix $(builddir)/lib/, $(OBJS))
FULL = $(PACKAGE_TARNAME)-$(PACKAGE_VERSION)
DISTFILES = $(DIRS) $(DATA) $(DOCS) $(srcs) $(hdrs) $(MANPAGES)

CPPCFLAGS += -I$(srcdir)/include

ifneq ($(builddir),$(srcdir))
CPPCFLAGS += -I$(builddir)/include
endif

ifeq ($(enable_debug),yes)
CPPCFLAGS += -DDBGVER="\"compiled by <$${USER}@`hostname`> at `date '+%Y-%m-%d %H:%M:%S'`\""
endif


# Quiet by default, 'make V=1' shows commands
V=0
ifeq ($(V), 0)
Q = @
E = @echo
else
Q = 
E = @true
endif

## actual targets now ##

# default target
all: $(builddir)/pgbouncer doc-all

# final executable
$(builddir)/pgbouncer: $(builddir)/config.mak $(objs)
	$(E) "	LD" $@
	$(Q) $(CC) -o $@ $(LDFLAGS) $(objs) $(LIBS)

# objects depend on all the headers
$(builddir)/lib/%.o: $(srcdir)/src/%.c $(builddir)/config.mak $(hdrs)
	@mkdir -p $(builddir)/lib
	$(E) "	CC" $<
	$(Q) $(CC) -c -o $@ $< $(DEFS) $(CFLAGS) $(CPPFLAGS)

# install binary and other stuff
install: $(builddir)/pgbouncer doc-install
	mkdir -p $(DESTDIR)$(bindir)
	mkdir -p $(DESTDIR)$(docdir)
	$(BININSTALL) -m 755 $(builddir)/pgbouncer $(DESTDIR)$(bindir)
	$(INSTALL) -m 644 $(srcdir)/etc/pgbouncer.ini  $(DESTDIR)$(docdir)

# create tarfile
tgz: config.mak $(DISTFILES) $(MANPAGES)
	rm -rf $(FULL) $(FULL).tgz
	mkdir $(FULL)
	(for f in $(DISTFILES); do echo $$f; done) | cpio -pm $(FULL)
	tar czf $(FULL).tgz $(FULL)
	rm -rf $(FULL)

doc/pgbouncer.1:
	$(MAKE) -C doc pgbouncer.1

doc/pgbouncer.5:
	$(MAKE) -C doc pgbouncer.5

# create debian package
deb: configure
	yada rebuild
	debuild -uc -us -b

# clean object files
clean: doc-clean
	rm -f $(objs) $(builddir)/pgbouncer

# clean configure results
distclean: clean doc-distclean
	rm -f include/config.h include/config.h.in~ config.log config.status config.mak
	rm -rf lib autom4te*

# clean autoconf results
realclean: distclean doc-realclean
	rm -f aclocal* include/config.h.in configure depcomp install-sh missing
	rm -f tags

# generate configure script and config.h.in
boot:
	autoreconf -i -f
	rm -rf autom4te* include/config.h.in~

# targets can depend on this to force ./configure
$(builddir)/config.mak::
	@test -f $(srcdir)/configure || { \
		 echo "Please run 'make boot && ./configure' first.";exit 1;}
	@test -f $@ || { echo "Please run ./configure first.";exit 1;}

doc-all doc-install doc-clean doc-distclean doc-realclean:
	@if test -d doc; then $(MAKE) -C doc $(subst doc-,,$@) DESTDIR=$(DESTDIR) ;\
	else true; fi


# targets can depend on this to force 'make boot'
configure::
	@test -f $@ || { echo "Please run 'make boot' first.";exit 1;}

# create tags file
tags: $(srcs) $(hdrs)
	if test -f ../libevent/event.h; then \
	  ctags $(srcs) $(hdrs) ../libevent/*.[ch]; \
	else \
	  ctags $(srcs) $(hdrs); \
	fi

# run sparse over code
check: config.mak
	REAL_CC="$(CC)" \
	$(MAKE) clean pgbouncer CC=cgcc

# profiled exe
pgbouncer.pg:
	$(CC) -pg $(DEFS) -g -O2 $(CPPFLAGS) $(LDFLAGS) -o $@ $(srcs) $(LIBS)

pg: pgbouncer.pg

# asm hacks
$(builddir)/lib/%.s: $(srcdir)/src/%.c config.mak $(hdrs)
	@mkdir -p $(builddir)/lib
	$(E) "	CC -S" $<
	$(Q) $(CC) -S -fverbose-asm -o $@ $< $(DEFS) $(CFLAGS) $(CPPFLAGS)
asms = $(objs:.o=.s)
asm: $(asms)

=== doc/Makefile ===
--- 
+++ 
@@ -7,15 +7,24 @@
 MANPAGES = pgbouncer.1 pgbouncer.5
 HTML = config.html usage.html todo.html faq.html
 
+ifneq ($(ASCIIDOC),)
 all: $(MANPAGES)
-
-html: $(HTML)
-
 install: $(MANPAGES)
 	mkdir -p $(DESTDIR)$(mandir)/man1/
 	mkdir -p $(DESTDIR)$(mandir)/man5/
 	install -m 644 pgbouncer.1 $(DESTDIR)$(mandir)/man1/
 	install -m 644 pgbouncer.5 $(DESTDIR)$(mandir)/man5/
+else
+all:
+
+install:
+	mkdir -p $(DESTDIR)$(mandir)/man1/
+	mkdir -p $(DESTDIR)$(mandir)/man5/
+	test -f pgbouncer.1 && install -m 644 pgbouncer.1 $(DESTDIR)$(mandir)/man1/
+	test -f pgbouncer.5 && install -m 644 pgbouncer.5 $(DESTDIR)$(mandir)/man5/
+endif
+
+html: $(HTML)
 
 upload:
 	devupload.sh overview.txt $(wiki)

=== test/Makefile ===

PGINC = -I$(shell pg_config --includedir)
PGLIB = -L$(shell pg_config --libdir)

include ../config.mak

CPPFLAGS += -I../include $(PGINC)
LDFLAGS += $(PGLIB)
LIBS += -lpq

all: asynctest

asynctest: asynctest.c
	$(CC) -o $@ $< $(DEFS) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $(LIBS)

clean:
	rm -f asynctest

## pgbouncer 1.3.1

=== doc/Makefile ===
--- 
+++ 
@@ -5,7 +5,7 @@
 -include ../config.mak
 
 MANPAGES = pgbouncer.1 pgbouncer.5
-HTML = config.html usage.html todo.html faq.html
+HTML = config.html usage.html todo.html faq.html README.html
 
 ifneq ($(ASCIIDOC),)
 all: $(MANPAGES)
@@ -48,6 +48,9 @@
 
 %.html: %.txt
 	asciidoc -a toc $<
+
+README.html: ../README
+	asciidoc -a toc -o $@ $<
 endif
 
 clean:

## pgbouncer 1.3.3

=== Makefile ===
--- 
+++ 
@@ -10,13 +10,16 @@
 # data & dirs to include in tgz
 DOCS = doc/overview.txt doc/usage.txt doc/config.txt doc/todo.txt
 MANPAGES = doc/pgbouncer.1 doc/pgbouncer.5
-DATA = README NEWS AUTHORS etc/pgbouncer.ini etc/userlist.txt Makefile \
+DATA = README NEWS AUTHORS COPYRIGHT etc/pgbouncer.ini etc/userlist.txt Makefile \
        config.mak.in include/config.h.in \
        configure configure.ac debian/packages debian/changelog doc/Makefile \
        test/Makefile test/asynctest.c test/conntest.sh test/ctest6000.ini \
        test/ctest7000.ini test/run-conntest.sh test/stress.py test/test.ini \
-       test/test.sh test/userlist.txt etc/example.debian.init.sh doc/fixman.py
-DIRS = doc etc include src debian test
+       test/test.sh test/userlist.txt etc/example.debian.init.sh doc/fixman.py \
+       win32/eventmsg.mc win32/eventmsg.rc win32/MSG00001.bin \
+       win32/Makefile win32/pgbevent.c \
+       win32/win32support.c win32/win32support.h
+DIRS = doc etc include src debian test win32
 
 # keep autoconf stuff separate
 -include config.mak
@@ -32,6 +35,7 @@
 objs = $(addprefix $(builddir)/lib/, $(OBJS))
 FULL = $(PACKAGE_TARNAME)-$(PACKAGE_VERSION)
 DISTFILES = $(DIRS) $(DATA) $(DOCS) $(srcs) $(hdrs) $(MANPAGES)
+exe = $(builddir)/pgbouncer$(EXT)
 
 CPPCFLAGS += -I$(srcdir)/include
 
@@ -43,6 +47,25 @@
 CPPCFLAGS += -DDBGVER="\"compiled by <$${USER}@`hostname`> at `date '+%Y-%m-%d %H:%M:%S'`\""
 endif
 
+ifeq ($(PORTNAME),win32)
+
+EXT = .exe
+
+CPPFLAGS += -I$(srcdir)/win32
+WSRCS = win32support.c
+WHDRS = win32support.h
+WOBJS = $(WSRCS:.c=.o)
+srcs += $(srcdir)/win32/win32support.c
+hdrs += $(srcdir)/win32/win32support.h
+objs += $(builddir)/lib/win32support.o
+
+dll = $(builddir)/pgbevent.dll
+dlldef = $(builddir)/lib/pgbevent.def
+dllobjs = $(builddir)/lib/eventmsg.o $(builddir)/lib/pgbevent.o
+
+DEFFLAGS = --export-all-symbols -A
+
+endif
 
 # Quiet by default, 'make V=1' shows commands
 V=0
@@ -57,10 +80,10 @@
 ## actual targets now ##
 
 # default target
-all: $(builddir)/pgbouncer doc-all
+all: $(exe) $(dll) doc-all
 
 # final executable
-$(builddir)/pgbouncer: $(builddir)/config.mak $(objs)
+$(exe): $(builddir)/config.mak $(objs)
 	$(E) "	LD" $@
 	$(Q) $(CC) -o $@ $(LDFLAGS) $(objs) $(LIBS)
 
@@ -70,12 +93,20 @@
 	$(E) "	CC" $<
 	$(Q) $(CC) -c -o $@ $< $(DEFS) $(CFLAGS) $(CPPFLAGS)
 
+$(builddir)/lib/%.o: $(srcdir)/win32/%.c $(builddir)/config.mak $(hdrs)
+	@mkdir -p $(builddir)/lib
+	$(E) "	CC" $<
+	$(Q) $(CC) -c -o $@ $< $(DEFS) $(CFLAGS) $(CPPFLAGS)
+
 # install binary and other stuff
-install: $(builddir)/pgbouncer doc-install
+install: $(exe) doc-install
 	mkdir -p $(DESTDIR)$(bindir)
 	mkdir -p $(DESTDIR)$(docdir)
-	$(BININSTALL) -m 755 $(builddir)/pgbouncer $(DESTDIR)$(bindir)
+	$(BININSTALL) -m 755 $(exe) $(DESTDIR)$(bindir)
 	$(INSTALL) -m 644 $(srcdir)/etc/pgbouncer.ini  $(DESTDIR)$(docdir)
+ifeq ($(PORTNAME),win32)
+	$(BININSTALL) -m 755 $(dll) $(DESTDIR)$(bindir)
+endif
 
 # create tarfile
 tgz: config.mak $(DISTFILES) $(MANPAGES)
@@ -98,7 +129,7 @@
 
 # clean object files
 clean: doc-clean
-	rm -f $(objs) $(builddir)/pgbouncer
+	rm -f $(objs) $(exe) $(dll) $(dlldef) $(dllobjs)
 
 # clean configure results
 distclean: clean doc-distclean
@@ -157,3 +188,23 @@
 asms = $(objs:.o=.s)
 asm: $(asms)
 
+ifeq ($(PORTNAME),win32)
+
+$(builddir)/lib/eventmsg.o: $(srcdir)/win32/eventmsg.rc
+	$(E) "	WINDRES" $<
+	$(Q) $(WINDRES) $< -o $@ --include-dir=$(srcdir)/win32
+
+$(dlldef): $(dllobjs)
+	$(E) "	DLLTOOL" $@
+	$(Q) $(DLLTOOL) $(DEFFLAGS) --output-def $@ $(dllobjs)
+
+# final executable
+$(dll): $(builddir)/config.mak $(dllobjs) $(dlldef)
+	$(E) "	DLLWRAP" $@
+	$(Q) $(DLLWRAP) --def $(dlldef) -o $@ $(dllobjs)
+
+endif
+
+stripped: $(exe) $(dll)
+	$(STRIP) $(exe) $(dll)
+

## pgbouncer 1.4.2

=== Makefile ===
--- 
+++ 
@@ -1,17 +1,18 @@
 
 # sources
 SRCS = client.c loader.c objects.c pooler.c proto.c sbuf.c server.c util.c \
-       admin.c stats.c takeover.c md5.c janitor.c pktbuf.c system.c main.c \
-       varcache.c aatree.c hash.c slab.c
+       admin.c stats.c takeover.c janitor.c pktbuf.c system.c main.c \
+       varcache.c dnslookup.c
 HDRS = client.h loader.h objects.h pooler.h proto.h sbuf.h server.h util.h \
-       admin.h stats.h takeover.h md5.h janitor.h pktbuf.h system.h bouncer.h \
-       list.h mbuf.h varcache.h aatree.h hash.h slab.h iobuf.h
+       admin.h stats.h takeover.h janitor.h pktbuf.h system.h bouncer.h \
+       varcache.h iobuf.h dnslookup.h
 
 # data & dirs to include in tgz
-DOCS = doc/overview.txt doc/usage.txt doc/config.txt doc/todo.txt
+DOCS = doc/overview.txt doc/usage.txt doc/config.txt doc/todo.txt doc/faq.txt
 MANPAGES = doc/pgbouncer.1 doc/pgbouncer.5
 DATA = README NEWS AUTHORS COPYRIGHT etc/pgbouncer.ini etc/userlist.txt Makefile \
-       config.mak.in include/config.h.in \
+       config.mak.in etc/mkauth.py \
+       config.sub config.guess install-sh autogen.sh \
        configure configure.ac debian/packages debian/changelog doc/Makefile \
        test/Makefile test/asynctest.c test/conntest.sh test/ctest6000.ini \
        test/ctest7000.ini test/run-conntest.sh test/stress.py test/test.ini \
@@ -28,23 +29,27 @@
 srcdir ?= .
 builddir ?= .
 
+local_hdrs = $(addprefix $(srcdir)/include/, $(HDRS))
+local_srcs = $(addprefix $(srcdir)/src/, $(SRCS))
+
+USUAL_DIR = $(srcdir)/lib
+USUAL_OBJDIR = $(builddir)/obj
+USUAL_LOCAL_SRCS = $(local_srcs) $(local_hdrs)
+include $(USUAL_DIR)/Setup.mk
+
 # calculate full-path values
 OBJS = $(SRCS:.c=.o)
-hdrs = $(addprefix $(srcdir)/include/, $(HDRS))
-srcs = $(addprefix $(srcdir)/src/, $(SRCS))
-objs = $(addprefix $(builddir)/lib/, $(OBJS))
+hdrs = $(local_hdrs) $(USUAL_HDRS)
+srcs = $(local_srcs)
+objs = $(addprefix $(builddir)/obj/, $(OBJS)) $(USUAL_OBJS)
 FULL = $(PACKAGE_TARNAME)-$(PACKAGE_VERSION)
-DISTFILES = $(DIRS) $(DATA) $(DOCS) $(srcs) $(hdrs) $(MANPAGES)
+DISTFILES = $(DIRS) $(DATA) $(DOCS) $(local_srcs) $(local_hdrs) $(MANPAGES)
 exe = $(builddir)/pgbouncer$(EXT)
 
-CPPCFLAGS += -I$(srcdir)/include
-
-ifneq ($(builddir),$(srcdir))
-CPPCFLAGS += -I$(builddir)/include
-endif
+CPPFLAGS := -I$(srcdir)/include $(USUAL_CPPFLAGS) $(CPPFLAGS)
 
 ifeq ($(enable_debug),yes)
-CPPCFLAGS += -DDBGVER="\"compiled by <$${USER}@`hostname`> at `date '+%Y-%m-%d %H:%M:%S'`\""
+CPPFLAGS += -DDBGVER="\"compiled by <$${USER}@`hostname`> at `date '+%Y-%m-%d %H:%M:%S'`\""
 endif
 
 ifeq ($(PORTNAME),win32)
@@ -57,11 +62,11 @@
 WOBJS = $(WSRCS:.c=.o)
 srcs += $(srcdir)/win32/win32support.c
 hdrs += $(srcdir)/win32/win32support.h
-objs += $(builddir)/lib/win32support.o
+objs += $(builddir)/obj/win32support.o
 
 dll = $(builddir)/pgbevent.dll
-dlldef = $(builddir)/lib/pgbevent.def
-dllobjs = $(builddir)/lib/eventmsg.o $(builddir)/lib/pgbevent.o
+dlldef = $(builddir)/obj/pgbevent.def
+dllobjs = $(builddir)/obj/eventmsg.o $(builddir)/obj/pgbevent.o
 
 DEFFLAGS = --export-all-symbols -A
 
@@ -85,16 +90,24 @@
 # final executable
 $(exe): $(builddir)/config.mak $(objs)
 	$(E) "	LD" $@
-	$(Q) $(CC) -o $@ $(LDFLAGS) $(objs) $(LIBS)
+	$(Q) $(CC) -o $@ $(CFLAGS) $(LDFLAGS) $(objs) $(LIBS)
+ifeq ($(enable_debug),no)
+	$(STRIP) $@
+endif
 
 # objects depend on all the headers
-$(builddir)/lib/%.o: $(srcdir)/src/%.c $(builddir)/config.mak $(hdrs)
-	@mkdir -p $(builddir)/lib
+$(builddir)/obj/%.o: $(srcdir)/src/%.c $(builddir)/config.mak $(hdrs)
+	@mkdir -p $(builddir)/obj
 	$(E) "	CC" $<
 	$(Q) $(CC) -c -o $@ $< $(DEFS) $(CFLAGS) $(CPPFLAGS)
 
-$(builddir)/lib/%.o: $(srcdir)/win32/%.c $(builddir)/config.mak $(hdrs)
-	@mkdir -p $(builddir)/lib
+$(builddir)/obj/%.o: $(srcdir)/win32/%.c $(builddir)/config.mak $(hdrs)
+	@mkdir -p $(builddir)/obj
+	$(E) "	CC" $<
+	$(Q) $(CC) -c -o $@ $< $(DEFS) $(CFLAGS) $(CPPFLAGS)
+
+$(builddir)/obj/%.o: $(USUAL_DIR)/usual/%.c $(builddir)/config.mak $(hdrs)
+	@mkdir -p $(builddir)/obj
 	$(E) "	CC" $<
 	$(Q) $(CC) -c -o $@ $< $(DEFS) $(CFLAGS) $(CPPFLAGS)
 
@@ -112,7 +125,8 @@
 tgz: config.mak $(DISTFILES) $(MANPAGES)
 	rm -rf $(FULL) $(FULL).tgz
 	mkdir $(FULL)
-	(for f in $(DISTFILES); do echo $$f; done) | cpio -pm $(FULL)
+	(for f in $(DISTFILES) $(USUAL_DIR) $(USUAL_DIST) $(USUAL_HDRS) $(USUAL_SRCS); \
+		do echo $$f; done) | cpio -pm $(FULL)
 	tar czf $(FULL).tgz $(FULL)
 	rm -rf $(FULL)
 
@@ -134,7 +148,7 @@
 # clean configure results
 distclean: clean doc-distclean
 	rm -f include/config.h include/config.h.in~ config.log config.status config.mak
-	rm -rf lib autom4te*
+	rm -rf obj autom4te*
 
 # clean autoconf results
 realclean: distclean doc-realclean
@@ -143,8 +157,7 @@
 
 # generate configure script and config.h.in
 boot:
-	autoreconf -i -f
-	rm -rf autom4te* include/config.h.in~
+	./autogen.sh
 
 # targets can depend on this to force ./configure
 $(builddir)/config.mak::
@@ -176,21 +189,22 @@
 
 # profiled exe
 pgbouncer.pg:
-	$(CC) -pg $(DEFS) -g -O2 $(CPPFLAGS) $(LDFLAGS) -o $@ $(srcs) $(LIBS)
+	$(CC) -pg $(DEFS) -g -O2 $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -o $@ $(srcs) $(LIBS)
 
 pg: pgbouncer.pg
 
 # asm hacks
-$(builddir)/lib/%.s: $(srcdir)/src/%.c config.mak $(hdrs)
-	@mkdir -p $(builddir)/lib
+$(builddir)/obj/%.s: $(srcdir)/src/%.c config.mak $(hdrs)
+	@mkdir -p $(builddir)/obj
 	$(E) "	CC -S" $<
-	$(Q) $(CC) -S -fverbose-asm -o $@ $< $(DEFS) $(CFLAGS) $(CPPFLAGS)
+	$(Q) $(CC) -S -fverbose-asm -o - $< $(DEFS) $(CFLAGS) $(CPPFLAGS) \
+	| cleanasm > $@
 asms = $(objs:.o=.s)
 asm: $(asms)
 
 ifeq ($(PORTNAME),win32)
 
-$(builddir)/lib/eventmsg.o: $(srcdir)/win32/eventmsg.rc
+$(builddir)/obj/eventmsg.o: $(srcdir)/win32/eventmsg.rc
 	$(E) "	WINDRES" $<
 	$(Q) $(WINDRES) $< -o $@ --include-dir=$(srcdir)/win32
 
@@ -202,9 +216,32 @@
 $(dll): $(builddir)/config.mak $(dllobjs) $(dlldef)
 	$(E) "	DLLWRAP" $@
 	$(Q) $(DLLWRAP) --def $(dlldef) -o $@ $(dllobjs)
-
-endif
+	$(STRIP) $@
+endif
+
+zip = pgbouncer-$(PACKAGE_VERSION)-win32.zip
+
+zip: configure
+	make distclean
+	./configure i586-mingw32msvc --disable-debug --with-libevent=/opt/apps/win32 --enable-evdns
+	make -C doc html
+	make pgbouncer.exe pgbevent.dll
+	cp COPYRIGHT doc/COPYRIGHT.txt
+	cp AUTHORS doc/AUTHORS.txt
+	make packzip
+
+packzip: pgbouncer.exe
+	rm -f $(zip)
+	zip $(zip) pgbouncer.exe pgbevent.dll doc/AUTHORS.txt doc/COPYRIGHT.txt doc/*.html etc/pgbouncer.ini etc/userlist.txt
+	rm -f doc/AUTHORS.txt doc/COPYRIGHT.txt
+
+zipupload: $(zip)
+	rsync $(zip) pgf:web/pgbouncer/htdocs/win32/
 
 stripped: $(exe) $(dll)
 	$(STRIP) $(exe) $(dll)
 
+tmp:
+	@echo CPPFLAGS=$(CPPFLAGS)
+	@echo USUAL_CPPFLAGS=$(USUAL_CPPFLAGS)
+	@echo USUAL_LDFLAGS=$(USUAL_LDFLAGS)

=== doc/Makefile ===
--- 
+++ 
@@ -1,11 +1,13 @@
 
-wiki = https://developer.skype.com/SkypeGarage/DbProjects/PgBouncer
-web = mkz@shell.pgfoundry.org:/home/pgfoundry.org/groups/pgbouncer/htdocs/
+web = pgf:/home/pgfoundry.org/groups/pgbouncer/htdocs/
 
 -include ../config.mak
 
 MANPAGES = pgbouncer.1 pgbouncer.5
 HTML = config.html usage.html todo.html faq.html README.html
+
+#FIXMAN = python fixman.py
+FIXMAN = cat
 
 ifneq ($(ASCIIDOC),)
 all: $(MANPAGES)
@@ -26,12 +28,6 @@
 
 html: $(HTML)
 
-upload:
-	devupload.sh overview.txt $(wiki)
-	#devupload.sh todo.txt $(wiki)/ToDo
-	#devupload.sh usage.txt $(wiki)/UsageInfo
-	#devupload.sh config.txt $(wiki)/ConfigFile
-
 ifneq ($(XMLTO),)
 pgbouncer.1: usage.xml
 	xmlto man $<
@@ -44,7 +40,7 @@
 %.xml: %.txt
 	#asciidoc -b docbook -d manpage -o - $< > $@
 	asciidoc -b docbook -d manpage -o - $< \
-	| python fixman.py > $@
+	| $(FIXMAN) > $@
 
 %.html: %.txt
 	asciidoc -a toc $<

=== debian/changelog ===
pgbouncer (1.4.2-2ubuntu0.1) precise-security; urgency=low

  * SECURITY UPDATE: denial of service when too long db name is provided
    (LP: #1083414)
    - debian/patches/2-CVE-2012-4575.patch: objects.c(add_database): fail
      gracefully if too long db name. Based on upstream patch.
    - CVE-2012-4575

 -- Christian Kuersteiner <ckuerste@gmx.ch>  Tue, 04 Dec 2012 22:21:56 +0700

pgbouncer (1.4.2-2build1) precise; urgency=low

  * No-change rebuild to drop spurious libsfgcc1 dependency on armhf.

 -- Adam Conrad <adconrad@0c3.net>  Fri, 02 Dec 2011 21:04:25 -0700

pgbouncer (1.4.2-2) unstable; urgency=low

  * Honor START=0 for the restart action.  Patch by Chris Lamb, thanks!
    Closes: #640796.

 -- Christoph Berg <myon@debian.org>  Thu, 08 Sep 2011 09:45:23 +0200

pgbouncer (1.4.2-1) unstable; urgency=low

  * New upstream release.

 -- Christoph Berg <myon@debian.org>  Fri, 17 Jun 2011 15:41:53 +0200

pgbouncer (1.4.1-1) unstable; urgency=low

  * New upstream release.
  * Remove the endian patch, implemented upstream.
  * Use source format 3.0 (quilt) because the upstream tarball has its own
    debian/ dir. Ignore lib/usual/config.h in source/options.

 -- Christoph Berg <myon@debian.org>  Tue, 12 Apr 2011 13:42:40 +0200

pgbouncer (1.4-2) unstable; urgency=low

  * Add myself as maintainer.
  * Use the system endian.h on *bsd. Closes: #619676
  * Add quilt to Build-Depends.
  * Move debian/config.patch to quilt and comment out example databases in
    config file.
  * Update long description.

 -- Christoph Berg <myon@debian.org>  Wed, 30 Mar 2011 17:29:39 +0200

pgbouncer (1.4-1) unstable; urgency=low

  * New upstream release.
  * Remove .orig file after patching pgbouncer.ini 

 -- Bernd Zeimetz <bzed@debian.org>  Mon, 14 Feb 2011 13:26:29 +0100

pgbouncer (1.3.3-2) unstable; urgency=low

  * Added myself to uploaders
  * Fixed debian/copyright to match reality
  * Updated standards version
  * Install configuration files with more secure permissions (closes: #548887)

 -- Peter Eisentraut <petere@debian.org>  Thu, 05 Aug 2010 21:57:00 +0300

pgbouncer (1.3.3-1) unstable; urgency=low

  * New upstream version. 
  * Bumping Standards-Version to 3.8.4, no changes needed. 
  * Removing dpatch - no patches needed anymore since several releases. 
  * Use source format 1.0 for easy backporting.

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 16 May 2010 03:15:41 +0200

pgbouncer (1.3.2-1) unstable; urgency=low

  * New upstream version. 

 -- Bernd Zeimetz <bzed@debian.org>  Wed, 24 Mar 2010 23:10:02 +0100

pgbouncer (1.3.1-3) unstable; urgency=low

  * Really change the init script now - unfortunately the old one found
    its way back into the package.

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 24 Jan 2010 12:24:34 +0100

pgbouncer (1.3.1-2) unstable; urgency=low

  * Chaging Section to database, which is the new section for
    database related tools.
  * Require $remote_fs on start/stop in the init script. (Lintian:
    init.d-script-missing-dependency-on-remote_fs)
  * Use pgbouncer as the name the init script provides instead
    of pgbouncer2. (Lintian: init.d-script-does-not-provide-itself)

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 24 Jan 2010 00:55:35 +0100

pgbouncer (1.3.1-1) unstable; urgency=low

  * New upstream release. 
  * debian/init: Use reload instead of restart when force-reload
    was called, thanks to Peter Eisentraut for the bug report.
    Closes: #538006
  * Ensure that pgbounce stops, even if clients are connected.
    Thanks to Cyril Bouthors for the patch. Closes: #523066
  * Bumping Standards-Version to 3.8.2, no changes needed. 

 -- Bernd Zeimetz <bzed@debian.org>  Thu, 23 Jul 2009 16:23:52 +0200

pgbouncer (1.3-1) unstable; urgency=low

  [ Fernando Ike de Oliveira ]
  * New upstream release.
  * debian/init:
    - pgbouncer.log and start script duplicated start message were removed.
    - patch that change pgbouncer to port 6432 (default upstream) was removed
  * debian/config.patch.
    - pgbouncer.ini patch new version was fixed.
  * win32 directory was removed from the original source code.

  [ Bernd Zeimetz ]
  * debian/watch, debian/uscan-repack.sh: Adding script to repackage upstream
    source with uscan automatically. The included debian and win32 dir will
    be removed.

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 01 Mar 2009 03:48:18 +0100

pgbouncer (1.2.3-2) unstable; urgency=low

  * debian/control:
    - pgbouncer needs a versioned dependency on libevent-dev (>= 1.3b).
  * debian/init:
    - Implementing reload by sending SIGHUP to the daemon.
    - Better start/stop log messages.
  * debian/default:
    - Explain how to change the daemon options.

 -- Bernd Zeimetz <bzed@debian.org>  Tue, 30 Sep 2008 10:42:06 +0200

pgbouncer (1.2.3-1) unstable; urgency=low

  [ Fernando Ike de Oliveira ]
  * New upstream Release.
  * Change listen port to 5433.
  * Added fields Enhances and Conflicts.

  [ Bernd Zeimetz ]
  * Changes done by Fernando Ike de Oliveira, but without a proper
    changelog entry:
    - The new upstream release closes: #499531
    - debian/control: Depend on postgresql-common to make sure the postgres
      user exists (Closes: #499521).
    - Fixed init script, not using -n option anymore (Closes: #499522)
    - Bumping Standards-Version to 3.8.0
  * Adding myself to Uploaders.
  * The following changes are a general cleanup of the package,
    unfortunately these things were never detected by the former
    sponsor. Sorry Fernando, but I also have to revert some of your
    recent changes.
    - debian/control:
      * Fixing the long description, removing the copy of the short
        description from it and switch to a better indenting.
      * Adding python as Build-Dependency, upstream is using it to
        fix the generated manpages.
      * Removing extra blank lines.
      * pgbouncer supports PostgreSQL versions 7.4 and higher, changing the
        Enhances field accordingly.


=== debian/control ===
Source: pgbouncer
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Christoph Berg <myon@debian.org>
Uploaders: Bernd Zeimetz <bzed@debian.org>, Peter Eisentraut <petere@debian.org>
Section: database
Priority: optional
Standards-Version: 3.9.2
Build-Depends: cdbs, debhelper (>= 7), libevent-dev (>= 1.3b), asciidoc, xmlto, python
Homepage: http://pgfoundry.org/projects/pgbouncer/
Vcs-Svn: svn://svn.debian.org/pkg-postgresql/trunk/pgbouncer/
Vcs-Browser: http://svn.debian.org/wsvn/pkg-postgresql/trunk/pgbouncer/

Package: pgbouncer
Architecture: any
Depends: lsb-base (>= 3.1), postgresql-common (>= 26), ${misc:Depends}, ${shlibs:Depends}
Enhances: postgresql (>= 7.4)
Description: lightweight connection pooler for PostgreSQL
 PgBouncer is a lightweight connection pooler for PostgreSQL providing the
 following features:
 .
  * Several levels of brutality when rotating connections: session pooling,
    transaction pooling, statement pooling.
  * Low memory requirements.
  * It is not tied to one backend server, the destination databases
    can reside on different hosts.
  * Supports online reconfiguration for most of the settings.
  * Supports online restart/upgrade.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

#DH_VERBOSE = 1

DEB_CONFIGURE_EXTRA_FLAGS := --bindir=/usr/sbin 
DEB_UPDATE_RCD_PARAMS := defaults 20 18

clean::
	find doc -name "pgbouncer.*" -exec rm {} \;

install/pgbouncer::
	rm -f $(CURDIR)/debian/pgbouncer/usr/share/doc/pgbouncer/pgbouncer.ini
	mkdir -p $(CURDIR)/debian/pgbouncer/etc/pgbouncer
	touch $(CURDIR)/debian/pgbouncer/etc/pgbouncer/userlist.txt

=== debian/watch ===
version=3
http://pgfoundry.org/frs/?group_id=1000258 /frs/download.php/[0-9]+/pgbouncer-([0-9.]+).tgz debian debian/uscan-repack.sh

## pgbouncer 1.5

=== Makefile ===

include config.mak

bin_PROGRAMS = pgbouncer

pgbouncer_SOURCES = \
	src/admin.c \
	src/client.c \
	src/dnslookup.c \
	src/janitor.c \
	src/loader.c \
	src/main.c \
	src/objects.c \
	src/pktbuf.c \
	src/pooler.c \
	src/proto.c \
	src/sbuf.c \
	src/server.c \
	src/stats.c \
	src/system.c \
	src/takeover.c \
	src/util.c \
	src/varcache.c \
	include/admin.h \
	include/bouncer.h \
	include/client.h \
	include/dnslookup.h \
	include/iobuf.h \
	include/janitor.h \
	include/loader.h \
	include/objects.h \
	include/pktbuf.h \
	include/pooler.h \
	include/proto.h \
	include/sbuf.h \
	include/server.h \
	include/stats.h \
	include/system.h \
	include/takeover.h \
	include/util.h \
	include/varcache.h

pgbouncer_CPPFLAGS = -Iinclude

pgbouncer_EMBED_LIBUSUAL = 1

# docs to install as-is
dist_doc_DATA = README NEWS etc/pgbouncer.ini etc/userlist.txt

DISTCLEANFILES = config.mak config.status lib/usual/config.h config.log

SUBDIRS = doc

# files in tgz
EXTRA_DIST = AUTHORS COPYRIGHT Makefile \
	     config.mak.in etc/mkauth.py \
	     config.sub config.guess install-sh autogen.sh \
	     configure configure.ac \
	     debian/compat debian/changelog debian/control debian/rules debian/copyright \
	     test/Makefile test/asynctest.c test/conntest.sh test/ctest6000.ini \
	     test/ctest7000.ini test/run-conntest.sh test/stress.py test/test.ini \
	     test/test.sh test/userlist.txt etc/example.debian.init.sh \
	     win32/Makefile \
	     $(shell cd lib; git ls-files | sed 's,^,lib/,') \
	     lib/usual/config.h.in

ifeq ($(enable_debug),yes)
CPPFLAGS += -DDBGVER="\"compiled by <$${USER}@`hostname`> at `date '+%Y-%m-%d %H:%M:%S'`\""
endif

#
# win32
#

pgbouncer_LIBS := $(LIBS)
LIBS :=

EXTRA_pgbouncer_SOURCES = win32/win32support.c win32/win32support.h
EXTRA_PROGRAMS = pgbevent
ifeq ($(PORTNAME),win32)
pgbouncer_CPPFLAGS += -Iwin32
pgbouncer_SOURCES += $(EXTRA_pgbouncer_SOURCES)
bin_PROGRAMS += pgbevent
endif

pgbevent_SOURCES = win32/pgbevent.c win32/eventmsg.rc \
		   win32/eventmsg.mc win32/MSG00001.bin
pgbevent_EXT = .dll
pgbevent_LINK = $(CC) -shared -Wl,--export-all-symbols -Wl,--add-stdcall-alias -o $@ $^

# .rc->.o
AM_LANGUAGES = RC
AM_LANG_RC_SRCEXTS = .rc
AM_LANG_RC_COMPILE = $(WINDRES) $< -o $@ --include-dir=$(srcdir)/win32
AM_LANG_RC_LINK = false

#
# now load antimake
#

USUAL_DIR = lib

abs_top_srcdir ?= $(CURDIR)
include $(abs_top_srcdir)/lib/mk/antimake.mk

config.mak:
	@echo "Please run ./configure"
	@exit 1

deb:
	debuild -b -us -uc

w32zip = pgbouncer-$(PACKAGE_VERSION)-win32.zip
zip: configure clean
	rm -rf buildexe
	mkdir buildexe
	cd buildexe \
		&& ../configure --host=i586-mingw32msvc --disable-debug \
			--with-libevent=/opt/apps/win32 --enable-evdns \
		&& make \
		&& i586-mingw32msvc-strip pgbouncer.exe pgbevent.dll \
		&& zip pgbouncer.zip pgbouncer.exe pgbevent.dll doc/*.html
	zip -l buildexe/pgbouncer.zip etc/pgbouncer.ini etc/userlist.txt
	mv buildexe/pgbouncer.zip $(w32zip)

zip-up: $(w32zip)
	rsync $(w32zip) pgf:web/pgbouncer/htdocs/win32/

tgz = pgbouncer-$(PACKAGE_VERSION).tar.gz
tgz-up: $(tgz)
	rsync $(tgz) pgf:web/pgbouncer/htdocs/testing/

=== doc/Makefile ===
-include ../config.mak

web = pgf:/home/pgfoundry.org/groups/pgbouncer/htdocs/

manpages = pgbouncer.1 pgbouncer.5

EXTRA_DIST = config.txt usage.txt todo.txt faq.txt Makefile $(manpages)

ifeq ($(ASCIIDOC),)
ifneq ($(wildcard pgbouncer.[15]),)
# no asciidoc, but we have manpages
dist_man_MANS = $(manpages)
endif
else
# we have asciidoc, build everything
man_MANS = $(manpages)
doc_DATA = config.html usage.html todo.html faq.html README.html
endif

SUBLOC = doc
abs_top_srcdir ?= $(CURDIR)/..
include $(abs_top_srcdir)/lib/mk/antimake.mk

# add rules only if asciidoc is defined
ifneq ($(ASCIIDOC),)

pgbouncer.1: usage.xml
	$(XMLTO) man $<

pgbouncer.5: config.xml
	$(XMLTO) man $<

%.xml: %.txt
	$(ASCIIDOC) -b docbook -d manpage -o $@ $<

%.html: %.txt
	$(ASCIIDOC) -a toc -o $@ $<

README.html: ../README
	$(ASCIIDOC) -a toc -o $@ $<

web: $(doc_DATA)
	rsync -av $(doc_DATA) $(web)/doc/

endif # ASCIIDOC

=== lib/Makefile ===

AM_CPPFLAGS = -I$(builddir) -I$(srcdir)

# main target
lib_LTLIBRARIES = libusual.la

# sources that are not always built
EXTRA_libusual_la_SOURCES = usual/pgsocket.h usual/pgsocket.c

# sources not in tar.gz
nodist_libusual_la_SOURCES = usual/config.h

# regular source files
libusual_la_SOURCES = usual/config.h.in \
	usual/aatree.h usual/aatree.c \
	usual/base.h usual/base.c usual/base_win32.h \
	usual/bits.h \
	usual/cbtree.h usual/cbtree.c \
	usual/cfparser.h usual/cfparser.c \
	usual/crc32.h usual/crc32.c \
	usual/ctype.h \
	usual/cxalloc.h usual/cxalloc.c \
	usual/cxextra.h usual/cxextra.c \
	usual/daemon.h usual/daemon.c \
	usual/endian.h \
	usual/err.h usual/err.c \
	usual/event.h usual/event.c \
	usual/fileutil.h usual/fileutil.c \
	usual/getopt.h usual/getopt.c \
	usual/hashtab-impl.h \
	usual/heap.h usual/heap.c \
	usual/list.h usual/list.c \
	usual/logging.h usual/logging.c \
	usual/lookup3.h usual/lookup3.c \
	usual/mbuf.h usual/mbuf.c \
	usual/md5.h usual/md5.c \
	usual/mdict.h usual/mdict.c \
	usual/mempool.h usual/mempool.c \
	usual/misc.h \
	usual/netdb.h usual/netdb.c \
	usual/pgutil.h usual/pgutil.c usual/pgutil_kwlookup.h \
	usual/pthread.h usual/pthread.c \
	usual/regex.h usual/regex.c \
	usual/safeio.h usual/safeio.c \
	usual/sha1.h usual/sha1.c \
	usual/shlist.h \
	usual/signal.h usual/signal.c \
	usual/slab.h usual/slab.c \
	usual/socket.h usual/socket.c usual/socket_ntop.c usual/socket_pton.c usual/socket_win32.h \
	usual/statlist.h \
	usual/string.h usual/string.c \
	usual/strpool.h usual/strpool.c \
	usual/time.h usual/time.c \
	usual/utf8.h usual/utf8.c

# we want to filter headers, so cannot use usual install method via _HEADERS
USUAL_HEADERS = $(filter %.h,$(libusual_la_SOURCES) $(nodist_libusual_la_SOURCES))

# define aclocal destination
aclocaldir = ${datarootdir}/aclocal
AM_DESTINATIONS = aclocal

# other files
dist_pkgdata_SCRIPTS = find_modules.sh
dist_pkgdata_DATA = Setup.mk
dist_aclocal_DATA = m4/usual.m4 m4/antimake.m4

# test program for link-test
noinst_PROGRAMS = test/compile
test_compile_SOURCES = test/compile.c
test_compile_LDADD = libusual.la

# extra clean files
DISTCLEANFILES = config.log build.mk config.status libtool config.mak
MAINTAINERCLEANFILES = build.mk.in configure install-sh ltmain.sh config.sub config.guess

# files for .tgz that are not mentioned in sources
EXTRA_DIST = $(MAINTAINERCLEANFILES)

# we dont build test subdir by default, but want to include in .tgz
DIST_SUBDIRS = test

# non-recursive subdir
EMBED_SUBDIRS = mk

#
# Launch Antimake
#
include build.mk

# filter headers when installing
install-local:
	@$(MKDIR_P) $(DESTDIR)$(includedir)/usual
	@for hdr in $(USUAL_HEADERS); do \
		echo Filtering $$hdr; \
		$(SED) -f mk/safe-headers.sed $$hdr \
		> $(DESTDIR)$(includedir)/usual/`basename $$hdr`; \
	done

# Give proper error message
build.mk:
	@echo "Please run ./configure first"
	@exit 1

%.pc: %.pc.in config.status
	./config.status --file $@

# run sparse over code
sparse: config.mak
	REAL_CC="$(CC)" \
	$(MAKE) clean libusual.a CC="cgcc -Wsparse-all -Wno-transparent-union"

# generate api documentation
dox:
	rm -rf doc/html/mk
	#rm -rf mk/temos/html
	doxygen doc/Doxyfile
	$(MAKE) -C mk/temos html
	cp -rp mk/temos/html doc/html/mk

#
# rest is for pgutil_kwlookup generation
#

PG_CONFIG ?= pg_config
KWLIST = $(shell $(PG_CONFIG) --includedir-server)/parser/kwlist.h
GPERF = gperf -m5

# requires 8.4+
kws:
	@test -f "$(KWLIST)" || { echo "kwlist.h not found"; exit 1; }
	grep '^PG_KEYWORD' "$(KWLIST)" \
	| grep -v UNRESERVED \
	| sed 's/.*"\(.*\)",.*, *\(.*\)[)].*/\1/' \
	>> usual/pgutil_kwlookup.gp

kwh:
	$(GPERF) usual/pgutil_kwlookup.g \
	| sed '/^#line/d' \
	> usual/pgutil_kwlookup.h

=== lib/test/Makefile ===

SUBLOC = test
DIST_SUBDIRS = attregex

USUAL_DIR = $(top_srcdir)

regtest_system_SOURCES = \
	test_string.c test_crypto.c test_aatree.c test_heap.c \
	test_common.c test_list.c tinytest.c test_cbtree.c \
	test_utf8.c test_strpool.c test_pgutil.c test_regex.c \
	test_cxalloc.c test_bits.c test_base.c test_netdb.c \
	test_cfparser.c test_endian.c test_hashtab.c test_mdict.c \
	test_shlist.c test_time.c test_hashing.c test_fileutil.c \
	test_socket.c test_getopt.c test_ctype.c \
	test_common.h tinytest.h tinytest_macros.h

regtest_compat_SOURCES = $(regtest_system_SOURCES)
nodist_regtest_compat_SOURCES = test_config.h

regtest_compat_EMBED_LIBUSUAL = 1
regtest_system_EMBED_LIBUSUAL = 1

regtest_system_LDADD = -lanl
regtest_system_LDFLAGS = -pthread

regtest_system_CPPFLAGS = -I$(USUAL_DIR) -I$(top_builddir) -I$(srcdir) -I$(builddir)
regtest_compat_CPPFLAGS = $(regtest_system_CPPFLAGS) -DUSUAL_TEST_CONFIG
regtest_compat_LDFLAGS = -pthread

EXTRA_DIST = Makefile tinytest_demo.c force_compat.sed test_cfparser.ini

noinst_PROGRAMS = regtest_system regtest_compat

include ../build.mk

$(builddir)/test_config.h: $(srcdir)/force_compat.sed $(top_builddir)/usual/config.h
	$(E) "	GEN-COMPAT" $@
	$(Q) sed -f $^ > $@

=== lib/mk/temos/Makefile ===
#
# This Makefile does not use Antimake because it must work
# even when Antimake is broken.
#

TEMOS = \
	antimake1 antimake2 antimake3 antimake4 antimake5 antimake6 \
	libusual1 libusual2 libusual3 libusual4 libusual5 libusual6 \



OUT = $(addsuffix .txt,$(addprefix output/, $(TEMOS)))
HTML = $(addsuffix .html,$(addprefix html/, $(TEMOS))) \
       html/index.html html/antimake.html

ExpFile = $(subst .temo,.txt,$(subst src/,expected/,$(1)))
OutFile = $(subst .temo,.txt,$(subst src/,output/,$(1)))

V ?= 0
ifeq ($(V),0)
E = @echo
Q = @
else
E = @true
Q =
endif

all: qtest

.PHONY: all test ack clean html

html: $(HTML)

am:
	rm -f html/anti*
	make

ftest: clean qtest
qtest: $(OUT)
	@diff -urN expected output > regressions.diff || { \
		less regressions.diff; \
		echo "FAIL: Result does not match expected output"; \
		exit 1; \
	}
	$(Q) rm -f regressions.diff
	$(E) "All OK"

#../antimake.mk ../../m4/usual.m4
output/%.txt: src/%.temo libtemo.sh
	@mkdir -p output
	@printf "$< ... "
	@bash $< > $@ && { cmp -s $@ $(call ExpFile,$<) && echo ok || echo failed; } \
		|| { echo "$< failed:" ; tail $(call OutFile,$<); exit 1; }

html/%.html: output/%.txt
	@mkdir -p html
	asciidoc -o - $< | grep -v '^Last updated ' > $@

ack:
	cp output/*.txt expected/

clean:
	rm -rf tmp html output regressions.diff

html/index.html: index.txt
	@mkdir -p html
	asciidoc -o - $< | grep -v '^Last updated ' > $@

html/antimake.html: ../antimake.txt
	@mkdir -p html
	asciidoc -a toc -o - $< | grep -v '^Last updated ' > $@

=== debian/changelog ===
pgbouncer (1.5-1) unstable; urgency=low

  [ Peter Eisentraut ]
  * Update watch file to allow .tar.gz in addition to .tgz
  * Remove obsolete README.source and repack support in watch file

  [ Christoph Berg ]
  * New upstream release.
  * Use start-stop-daemon for stopping the daemon.  Closes: #641568.
  * Use pgbouncer -R to restart in place, thanks Cody Cutrer for the patch.
    Closes: #657204.
  * Update URL in README.Debian.  Closes: #655283.

 -- Christoph Berg <myon@debian.org>  Fri, 27 Jan 2012 17:40:22 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: pgbouncer
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Christoph Berg <myon@debian.org>
+Maintainer: Christoph Berg <myon@debian.org>
 Uploaders: Bernd Zeimetz <bzed@debian.org>, Peter Eisentraut <petere@debian.org>
 Section: database
 Priority: optional

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

DEB_CONFIGURE_EXTRA_FLAGS := --bindir=/usr/sbin
DEB_DH_INSTALLINIT_ARGS := -R

clean::
	find doc -name "pgbouncer.*" -exec rm {} \;
	rm -f doc/*.xml

install/pgbouncer::
	rm -f $(CURDIR)/debian/pgbouncer/usr/share/doc/pgbouncer/pgbouncer.ini
	mkdir -p $(CURDIR)/debian/pgbouncer/etc/pgbouncer
	touch $(CURDIR)/debian/pgbouncer/etc/pgbouncer/userlist.txt

## pgbouncer 1.5.2

=== Makefile ===
--- 
+++ 
@@ -61,8 +61,16 @@
 	     test/ctest7000.ini test/run-conntest.sh test/stress.py test/test.ini \
 	     test/test.sh test/userlist.txt etc/example.debian.init.sh \
 	     win32/Makefile \
-	     $(shell cd lib; git ls-files | sed 's,^,lib/,') \
-	     lib/usual/config.h.in
+	     $(LIBUSUAL_DIST)
+
+# libusual files (fixme: list should be provided by libusual...)
+LIBUSUAL_DIST = $(filter-out %/config.h, $(wildcard \
+		lib/usual/*.[chg] lib/m4/*.m4 \
+		lib/usual/config.h.in \
+		lib/mk/antimake.mk lib/mk/antimake.txt \
+		lib/mk/install-sh lib/mk/std-autogen.sh \
+		lib/README lib/COPYRIGHT \
+		lib/find_modules.sh ))
 
 ifeq ($(enable_debug),yes)
 CPPFLAGS += -DDBGVER="\"compiled by <$${USER}@`hostname`> at `date '+%Y-%m-%d %H:%M:%S'`\""
@@ -130,3 +138,7 @@
 tgz-up: $(tgz)
 	rsync $(tgz) pgf:web/pgbouncer/htdocs/testing/
 
+.PHONY: tags
+tags:
+	ctags src/*.c include/*.h lib/usual/*.[ch]
+

=== win32/Makefile ===

# create eventmsg.rc + MSG*.bin
eventmsg.rc: eventmsg.mc
	mc.exe eventmsg.mc

=== debian/changelog ===
pgbouncer (1.5.2-4+deb7u1) wheezy; urgency=medium

  * Fix remote crash - invalid packet order causes lookup of NULL pointer.
    Not exploitable, just DoS. (CVE-2015-4054)
    Cherry-picked from upstream 1.5.5.

 -- Christoph Berg <myon@debian.org>  Sat, 23 May 2015 22:58:29 +0200

pgbouncer (1.5.2-4) unstable; urgency=medium

  * Cherry-pick from 1.5.3:  Closes: #692103.
    http://git.postgresql.org/gitweb/?p=pgbouncer.git;a=commitdiff;h=4b92112b820830b30cd7bc91bef3dd8f35305525
    Thanks to Markus Wanner for helping fix this.

    = Critical fix =
    * Too long database names can lead to crash, which
      is remotely triggerable if autodbs are enabled.

      The original checks assumed all names come from config files,
      thus using fatal() was fine, but when autodbs are enabled
      - by '*' in [databases] section - the database name can come
      from network thus making remote shutdown possible.

 -- Christoph Berg <myon@debian.org>  Fri, 02 Nov 2012 10:05:27 +0100

pgbouncer (1.5.2-3) unstable; urgency=low

  * Re-add check for START=0 in the init script.  Spotted by Sergey Burladyan.
    Closes: #687577.
  * Repository moved to git.

 -- Christoph Berg <myon@debian.org>  Sun, 07 Oct 2012 19:16:34 +0200

pgbouncer (1.5.2-2) unstable; urgency=low

  * Init script: Use --oknodo.  Closes: #681978.
    Create /var/run/postgresql when missing.  Closes: #681372.

 -- Christoph Berg <myon@debian.org>  Thu, 26 Jul 2012 13:12:23 +0200

pgbouncer (1.5.2-1) unstable; urgency=low

  * New upstream release.

 -- Christoph Berg <myon@debian.org>  Mon, 11 Jun 2012 17:52:32 +0200

pgbouncer (1.5.1-1) unstable; urgency=low

  [ Peter Eisentraut ]
  * Remove duplicate userlist.txt from doc directory

  [ Christoph Berg ]
  * Replace lsb init functions with plain echo. Spotted by Alexey Potehin.
  * Refresh debian-changes patch, most of our changes went upstream.

 -- Christoph Berg <myon@debian.org>  Mon, 30 Apr 2012 14:31:35 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Uploaders: Bernd Zeimetz <bzed@debian.org>, Peter Eisentraut <petere@debian.org>
 Section: database
 Priority: optional
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Build-Depends: cdbs, debhelper (>= 7), libevent-dev (>= 1.3b), asciidoc, xmlto, python
 Homepage: http://pgfoundry.org/projects/pgbouncer/
-Vcs-Svn: svn://svn.debian.org/pkg-postgresql/trunk/pgbouncer/
-Vcs-Browser: http://svn.debian.org/wsvn/pkg-postgresql/trunk/pgbouncer/
+Vcs-Git: git://anonscm.debian.org/pkg-postgresql/pgbouncer.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-postgresql/pgbouncer.git
 
 Package: pgbouncer
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,6 @@
 	rm -f doc/*.xml
 
 install/pgbouncer::
-	rm -f $(CURDIR)/debian/pgbouncer/usr/share/doc/pgbouncer/pgbouncer.ini
+	rm -f $(addprefix $(CURDIR)/debian/pgbouncer/usr/share/doc/pgbouncer/,pgbouncer.ini userlist.txt)
 	mkdir -p $(CURDIR)/debian/pgbouncer/etc/pgbouncer
 	touch $(CURDIR)/debian/pgbouncer/etc/pgbouncer/userlist.txt

=== debian/watch ===
version=3
http://pgfoundry.org/frs/?group_id=1000258 /frs/download.php/[0-9]+/pgbouncer-([0-9.]+).(?:tgz|tar.gz)
